
#ifdef GL_ES
#define MEDIUMP     mediump
#define HIGHP       highp
#define LOWP        lowp

#else
#define MEDIUMP
#define HIGHP
#define LOWP
#endif

uniform sampler2D u_texture1;
uniform sampler2D u_texture2;

varying LOWP vec2 scrollUV1;
varying LOWP vec2 scrollUV2;
varying HIGHP vec2 scrollUV0;
uniform MEDIUMP vec4 dist_strength;

varying LOWP vec4 v_color;
varying vec2 v_texcoord;

void main()
{
	vec2 distortTex1 = texture2D(u_texture2, scrollUV1).rg*2.0-1.0;
	vec2 distortTex2 = texture2D(u_texture2, scrollUV2).rg*2.0-1.0;
	vec2 final_uv_distortion1 = dist_strength.xy*distortTex1*v_color.g;
	vec2 final_uv_distortion2 = dist_strength.zw*distortTex2*v_color.g;

	vec4 color = texture2D(u_texture1, scrollUV0+final_uv_distortion1+final_uv_distortion2);
	gl_FragColor = vec4(color.rgb, v_color.a * color.a * color.a * 30.0);
}