#ifdef GL_ES
#define MEDIUMP     mediump
#define HIGHP       highp
#define LOWP        lowp

#else
#define MEDIUMP
#define HIGHP
#define LOWP
#endif

attribute vec4 a_vertex;
attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

uniform MEDIUMP vec4 dist_tiling_scroll1;
uniform MEDIUMP vec4 dist_tiling_scroll2;
uniform HIGHP vec4 uv_tiling_scroll;
uniform HIGHP float u_time;

varying LOWP vec4 v_color;
varying HIGHP vec2 v_texcoord;
varying LOWP vec2 scrollUV1;
varying LOWP vec2 scrollUV2;
varying HIGHP vec2 scrollUV0;

void main()
{
	v_color = a_color;
	v_texcoord = a_texCoord;

	gl_Position = CC_MVPMatrix * a_position;

	scrollUV1 = v_texcoord.xy*dist_tiling_scroll1.xy+fract(v_color.b*u_time*dist_tiling_scroll1.zw);
	scrollUV2 = v_texcoord.xy*dist_tiling_scroll2.xy+fract(v_color.b*u_time*dist_tiling_scroll2.zw);
	scrollUV0 = v_texcoord.xy*uv_tiling_scroll.xy+fract(u_time*uv_tiling_scroll.zw*vec2(0,v_color.r));
}