#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;

float Threshold = 0.3; // 0 - 1
float Intensity = 0.7.; // 0 - 2
float BlurSize = 3.;  // 0 - 6

vec4 BlurColor (in vec2 Coord, in sampler2D Tex, in float MipBias)
{
   vec2 TexelSize = MipBias/resolution.xy;
    
    vec4  Color = texture2D(Tex, Coord, MipBias);
    Color += texture2D(Tex, Coord + vec2(TexelSize.x,0.0), MipBias);      
    Color += texture2D(Tex, Coord + vec2(-TexelSize.x,0.0), MipBias);     
    Color += texture2D(Tex, Coord + vec2(0.0,TexelSize.y), MipBias);      
    Color += texture2D(Tex, Coord + vec2(0.0,-TexelSize.y), MipBias);     
    Color += texture2D(Tex, Coord + vec2(TexelSize.x,TexelSize.y), MipBias);       
    Color += texture2D(Tex, Coord + vec2(-TexelSize.x,TexelSize.y), MipBias);      
    Color += texture2D(Tex, Coord + vec2(TexelSize.x,-TexelSize.y), MipBias);      
    Color += texture2D(Tex, Coord + vec2(-TexelSize.x,-TexelSize.y), MipBias);    

    return Color/9.0;
}

void main()
{
   vec4 sum = vec4(0);
   vec2 texcoord = v_texCoord.xy;
   vec4 Color = texture2D(CC_Texture0, texcoord);
    
    float speed = 0.4;
    float thresholdDelta = 1.0;// sin(CC_Time[1] * speed) * Threshold;
    float intenDelta = 1.0; //sin(CC_Time[1] * speed) * Intensity;
    float blurSizeDelta = 1.0;// sin(CC_Time[1] * speed) * BlurSize;

    vec4 Highlight = clamp(BlurColor(texcoord, CC_Texture0, BlurSize * blurSizeDelta)-Threshold * thresholdDelta,0.0,1.0)*1.0/(1.0-Threshold * thresholdDelta);
        
    //gl_FragColor = 1.0-(1.0-Color)*(1.0-Highlight*Intensity * sinValue); //Screen Blend Mode
    gl_FragColor = 1.0-(1.0-Color)*(1.0-Highlight*Intensity * intenDelta); //Screen Blend Mode

}