#ifdef GL_ES
//precision mediump float;
precision highp float;//only to avoid u_time overflow
#endif

//this shader is ref to ccShader_PositionTextureColor_frag.h
//v_fragmentColor is corresponding to sprite's opacity

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_time;
uniform float u_randValue;
uniform sampler2D u_maskTex;
uniform sampler2D u_maskTex2;
uniform sampler2D u_noiseTex;
uniform sampler2D u_noiseTex2;
//uniform sampler2D u_noiseTex3;

//uniform vec2 u_noiseSize;
//uniform vec2 u_spriteSize;
//uniform vec2 u_LUPos;
//uniform float u_highlight;
//uniform float u_PorN;
//uniform vec2 u_scale;
//uniform float u_kLightColor;
//uniform float u_kGlowColor;
//uniform float u_noiseScale;
//uniform float u_colorR;
//uniform float u_colorG;
//uniform float u_colorB;

vec4 u_PorNVec4 = vec4(1.0, -1.0, 1.0, -1.0);
vec4 scaleYVec4 = vec4(1.3, 1.3, 0.8, 0.8) ; 
vec4 u_kGlowColorVec4 = vec4(2.0, 2.0, 3, 3);
vec4 u_kLightColorVec4 = vec4(0.0, 0.0, 0.5, 0.5);
vec4 u_noiseScaleVec4 = vec4(2.2, 2.2, 1.5, 1.5) ;
vec4 u_highlightVec4 = vec4(1.0, 1.0, 1.0, 1.0);
vec2 u_LUPosFixed = vec2(0.0, 0.0);

vec2 noiseSize = vec2(256.0, 256.0);
vec2 spriteSize = vec2(256.0, 64.0);

float rand(vec2 co){
    return fract(sin(dot(co.xy, vec2(12.9898,78.233))) * 43758.5453);
}

void main()
{
    vec2 u_noiseSize;
    vec2 u_spriteSize;
    vec2 u_LUPos;
    vec2 u_scale;
    float u_highlight;
    float u_PorN;
    float u_kLightColor;
    float u_kGlowColor;
    float u_noiseScale;
    float u_colorR = 0.5;
    float u_colorG = 0.663;
    float u_colorB = 1.0;

    float scaleY;
    float index = 255.0 * v_fragmentColor.z;
    if (index < 15.0) {
        u_highlight = u_highlightVec4.x;
        u_PorN = u_PorNVec4.x;
        u_kLightColor = u_kLightColorVec4.x;
        u_kGlowColor = u_kGlowColorVec4.x;
        u_noiseScale = u_noiseScaleVec4.x;

        scaleY = scaleYVec4.x;
    } else if (index > 15.0 && index < 25.0) {
        u_highlight = u_highlightVec4.y;
        u_PorN = u_PorNVec4.y;
        u_kLightColor = u_kLightColorVec4.y;
        u_kGlowColor = u_kGlowColorVec4.y;
        u_noiseScale = u_noiseScaleVec4.y;

        scaleY = scaleYVec4.y;
    } else if (index > 25.0 && index < 35.0) {
        u_highlight = u_highlightVec4.z;
        u_PorN = u_PorNVec4.z;
        u_kLightColor = u_kLightColorVec4.z;
        u_kGlowColor = u_kGlowColorVec4.z;
        u_noiseScale = u_noiseScaleVec4.z;

        scaleY = scaleYVec4.z;
    } else {
        u_highlight = u_highlightVec4.w;
        u_PorN = u_PorNVec4.w;
        u_kLightColor = u_kLightColorVec4.w;
        u_kGlowColor = u_kGlowColorVec4.w;
        u_noiseScale = u_noiseScaleVec4.w;

        scaleY = scaleYVec4.w;
    }

    //float scrollTime = fract(0.015 * u_time);// CC_Time[0]
    // float scrollTime = -6.0 * CC_Time[0];
    // vec2 distortionScroll = vec2(scrollTime, 0.0);
    // vec4 distortTex = texture2D(u_noiseTex3, vec2(1.5, 0.5)*v_texCoord + distortionScroll);
    // vec2 distortion = distortTex.xy;
    // distortion.x = pow(distortion.x, 0.5);
    
    // const float xDistort = 0.8;
    // vec2 distortionOffset = v_texCoord.x * mix(vec2(0.3, -xDistort), vec2(0.0, xDistort), distortion);

    float scaleX = v_fragmentColor.x * 255.0 + v_fragmentColor.y * 255.0 / 100.0;
    u_scale = vec2(scaleX, scaleY);
    u_noiseSize = vec2(noiseSize.x, noiseSize.y);
    u_LUPos = vec2(u_LUPosFixed.x, u_LUPosFixed.y);
    u_spriteSize = vec2(spriteSize.x * scaleX, spriteSize.y * scaleY);

    //float randv = texture2D(u_noiseTex2, v_texCoord).r;
  
    vec2 distortionOffset = vec2(0.0,0.0);
    vec2  texCoord = v_texCoord;
    float time = CC_Time[1] * 15.0;
    //texCoord.y += 0.1 * cos(10.0 * ( 0.2 + randv * 0.5) * texCoord.x + time ); //
    texCoord.y += 0.1 * cos(7.0 * texCoord.x + time);

    // v_texCoord = texCoord;

    vec2 texCoord_mask;
    texCoord_mask.x=(texCoord.x+u_time*0.05)*u_scale.x;
    texCoord_mask.y=texCoord.y;
    
    vec2 texCoord_mask2;
    texCoord_mask2.x=(texCoord.x+u_time*0.1)*u_scale.x;
    texCoord_mask2.y=texCoord.y;
    
    vec4 maskTexColor=texture2D(u_maskTex, texCoord_mask + distortionOffset);
    vec4 maskTexColor2=texture2D(u_maskTex2, texCoord_mask2 + distortionOffset);

    vec4 lightTexColor= texture2D(CC_Texture0, texCoord);//texture2D(CC_Texture0, v_texCoord+vec2(u_time*10.0,0.0)); distortionOffset
    
    vec2 texCoord_noise;
    
    texCoord_noise.x = (texCoord.x*u_spriteSize.x+u_LUPos.x)/u_noiseSize.x;
    texCoord_noise.y = (texCoord.y*u_spriteSize.y+u_noiseSize.y-u_LUPos.y)/u_noiseSize.y;


    vec2 texCoord_noise1=texCoord_noise;
    texCoord_noise1*=u_noiseScale;
    texCoord_noise1+=vec2(0.0,u_time*0.2*u_PorN);
    
    vec2 texCoord_noise2=texCoord_noise;
    texCoord_noise2*=u_noiseScale;
    texCoord_noise2+=vec2(0.0, u_time*0.4*u_PorN);
    
    vec4 noiseTexColor1=texture2D(u_noiseTex, texCoord_noise1 + distortionOffset);
    vec4 noiseTexColor2=texture2D(u_noiseTex2, texCoord_noise2 + distortionOffset); //+ distortionOffset
 
    
    float deep;
    if(v_texCoord.y<0.5+0.001){
        deep=(u_PorN==-1.0)?0.0:v_texCoord.y*v_texCoord.y*1.0/0.25;
    }
    if(v_texCoord.y>=0.5-0.001){
        deep=(u_PorN==-1.0)?(1.0-v_texCoord.y)*(1.0-v_texCoord.y)*1.0/0.25:0.0;
    
    }
    
   
    float deep2;
    vec2 curPoint=v_texCoord*u_spriteSize;
    float curveX=u_spriteSize.x-0.05*(curPoint.y-0.5*u_spriteSize.y)*(curPoint.y-0.5*u_spriteSize.y)-10.0;//-30.0;
    if(curPoint.x<curveX){
        deep2=1.0;
    }else{//curPoint.x>=curveX
        curPoint.x-curveX;
        deep2=1.0-1.0/(u_spriteSize.x-curveX)*(curPoint.x-curveX);
    }

    vec4 glowColor =u_kGlowColor*(noiseTexColor1 + noiseTexColor2)*(maskTexColor+maskTexColor2)/2.0*u_highlight; //noiseTexColor1 +   //+maskTexColor2
    vec4 lightColor =lightTexColor*u_kLightColor;
    vec4 finalColor = glowColor*vec4(u_colorR,u_colorG,u_colorB,1.0)+lightColor;
    
    float Gray = finalColor.r*0.299 + finalColor.g*0.587 + finalColor.b*0.114;
    
    finalColor.a=Gray*2.0;
    finalColor*=deep*deep2;
    gl_FragColor= finalColor;
    
    //gl_FragColor = vec4(u_randValue,u_randValue,u_randValue,1);// v_fragmentColor;
}
