#ifdef GL_ES
precision highp float;
#endif

uniform float u_time;
uniform float u_duration;
uniform float u_velocity;
uniform vec2 u_center;
uniform float u_xRatio;
uniform vec2 resolution;
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;
varying vec2 v_position;
void main()
{
    float caustic = 0.0;
    vec2 distVec = u_center - v_position;
    // distVec.x *= u_xRatio;
    distVec /= resolution.y;
    float dist = length(distVec);
 	float frequence = 70.0;

 	float r = 3.1415926/(2.0*frequence) * 3.0; 
 	float start = u_time * u_velocity;
 	float end = start + r * 4.0;
    float offset = max(1.0 - 4.0 * u_time,0.0);;//控制波纹出来的波纹幅度
    
 	if (dist <= end) {
 		caustic = 0.08 * (1.0 - offset) * cos(frequence*(dist - (start+r) * 0.6));
 	}
    if (caustic < .0) {
        caustic = caustic * 0.2;
    }
    float offLong = 1.0 - dist;//越远离中心的offLong值约小
    vec4 retCol = texture2D(CC_Texture0, v_texCoord + normalize(distVec) * caustic * offLong  * offLong);
    float a =  max(0.0,1.0 - u_time);

    a = retCol.a * a * a;

    float power = 1.0+clamp(caustic, 0.0, 0.1);
    gl_FragColor = vec4(retCol.xyz * power * a , a); //* a * a

}
