/*
 uniform mat4 CC_PMatrix;
 uniform mat4 CC_MVMatrix;
 uniform mat4 CC_MVPMatrix;
 uniform mat3 CC_NormalMatrix;
 uniform vec4 CC_Time;
 uniform vec4 CC_SinTime;
 uniform vec4 CC_CosTime;
 uniform vec4 CC_Random01;
 uniform sampler2D CC_Texture0;
 uniform sampler2D CC_Texture1;
 uniform sampler2D CC_Texture2;
 uniform sampler2D CC_Texture3;
 //CC INCLUDES END
 
 float time = _director->getTotalFrames() * _director->getAnimationInterval();
 setUniformLocationWith4f(_builtInUniforms[GLProgram::UNIFORM_TIME], time/10.0, time, time*2, time*4);
 setUniformLocationWith4f(_builtInUniforms[GLProgram::UNIFORM_SIN_TIME], time/8.0, time/4.0, time/2.0, sinf(time));
 setUniformLocationWith4f(_builtInUniforms[GLProgram::UNIFORM_COS_TIME], time/8.0, time/4.0, time/2.0, cosf(time));
 */

#ifdef GL_ES
precision highp float;
#endif //mediump

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec2 v_position;

uniform vec2 center;
uniform vec3 shockParams; //Amplitude? bien do, Refraction? do khuc xa,  Width? be ngang
uniform float currentRadius;
uniform vec2 resolution;
uniform vec2 vertOffset;

// ---- 8< ---- GLSL Number Printing - @P_Malin ---- 8< ----
// Creative Commons CC0 1.0 Universal (CC-0) 
// https://www.shadertoy.com/view/4sBSWW

float DigitBin(int x)
{
    return x==0?480599.0:x==1?139810.0:x==2?476951.0:x==3?476999.0:x==4?350020.0:x==5?464711.0:x==6?464727.0:x==7?476228.0:x==8?481111.0:x==9?481095.0:0.0;
}

float PrintValue(vec2 fragCoord, vec2 vPixelCoords, vec2 vFontSize, float fValue, float fMaxDigits, float fDecimalPlaces)
{
    vec2 vStringCharCoords = (fragCoord.xy - vPixelCoords) / vFontSize;
    if ((vStringCharCoords.y < 0.0) || (vStringCharCoords.y >= 1.0)) return 0.0;
    float fLog10Value = log2(abs(fValue)) / log2(10.0);
    float fBiggestIndex = max(floor(fLog10Value), 0.0);
    float fDigitIndex = fMaxDigits - floor(vStringCharCoords.x);
    float fCharBin = 0.0;
    if(fDigitIndex > (-fDecimalPlaces - 1.01)) {
        if(fDigitIndex > fBiggestIndex) {
            if((fValue < 0.0) && (fDigitIndex < (fBiggestIndex+1.5))) fCharBin = 1792.0;
        } else {        
            if(fDigitIndex == -1.0) {
                if(fDecimalPlaces > 0.0) fCharBin = 2.0;
            } else {
                if(fDigitIndex < 0.0) fDigitIndex += 1.0;
                float fDigitValue = (abs(fValue / (pow(10.0, fDigitIndex))));
                float kFix = 0.0001;
                fCharBin = DigitBin(int(floor(mod(kFix+fDigitValue, 10.0))));
            }       
        }
    }
    return floor(mod((fCharBin / pow(2.0, floor(fract(vStringCharCoords.x) * 4.0) + (floor(vStringCharCoords.y * 5.0) * 4.0))), 2.0));
}

//打印日期
vec3 debug(vec2 fragCoord,float value)
{
    vec3 vColour = vec3(0.0);

    // Multiples of 4x5 work best
    vec2 vFontSize = vec2(8.0, 15.0);

    // Print Date
    vColour = mix( vColour, vec3(1.0, 1.0, 0.0), PrintValue(fragCoord, vec2(0.0 + 72.0, 100.0), vFontSize, value, 4.0, 0.0));
    
    return vColour;
}

void main()
{
    //vec2 texCoord = v_position.xy / resolution.xy;
    vec4 color = texture2D(CC_Texture0, v_texCoord);

    //gl_FragColor = vec4(1,1,1,1);
    
    
    if(color.a == 0.0)
    {
        gl_FragColor = color;
    }
    else
    {
        vec2 texCoord = v_texCoord;
        
        float dis = distance(v_position - vertOffset, center);
        
        if (dis <= (currentRadius + shockParams.z) && dis >= (currentRadius - shockParams.z))
        {
            float diff = (dis - currentRadius) / shockParams.z; //form -1 -> 1
            
            float powDiff = (1.0 - pow(abs(diff), shockParams.y)) * diff;
            
            vec2 dir = normalize(center - v_position + vertOffset);	 // / resolution.xy;
            
            dir = dir * powDiff;
            
            texCoord = texCoord + (dir * shockParams.x).xy / resolution.xy;
        }
        
        //vec3 debugColor = debug(vec2(resolution.x * texCoord.x,resolution.y * texCoord.y),resolution.x);
        gl_FragColor = v_fragmentColor * texture2D(CC_Texture0, texCoord);//  + vec4(debugColor,0.0);
    }
}