#ifdef GL_ES
precision highp float;
#endif

uniform float u_time;
uniform float u_duration;
uniform float u_velocity;
uniform vec2 u_center;
uniform float u_xRatio;

varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

void main()
{
    float caustic = 0.0;
    vec2 distVec = u_center - v_texCoord;
    distVec.x *= u_xRatio;
    float dist = length(distVec);
 	float frequence = 60.0;

 	float r = 3.1415926/(2.0*frequence) * 3.0; 
 	float start = u_time * u_velocity - r;
 	float end = start + r * 2.0;
 	if (dist <= end) {
 		caustic = 0.5 * cos(frequence*(dist - (start+r)));
 	}
    if (caustic < .0) {
        caustic = caustic * 0.2;
    }
    vec4 retCol = texture2D(CC_Texture0, v_texCoord + normalize(distVec) * caustic);
    //float a = 1.0 - u_time/u_duration * u_time/u_duration * u_time/u_duration;
    gl_FragColor = v_fragmentColor * retCol;

}