/*
 * cocos2d for iPhone: http://www.cocos2d-iphone.org
 *
 * Copyright (c) 2011 Ricardo Quesada
 * Copyright (c) 2012 Zynga Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifdef GL_ES
precision highp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec2 v_position;

uniform vec2 center;
uniform vec3 shockParams; //Amplitude? bien do, Refraction? do khuc xa,  Width? be ngang
uniform float currentRadius;
uniform vec2 resolution;

// ---- 8< ---- GLSL Number Printing - @P_Malin ---- 8< ----
// Creative Commons CC0 1.0 Universal (CC-0) 
// https://www.shadertoy.com/view/4sBSWW

float DigitBin(int x)
{
    return x==0?480599.0:x==1?139810.0:x==2?476951.0:x==3?476999.0:x==4?350020.0:x==5?464711.0:x==6?464727.0:x==7?476228.0:x==8?481111.0:x==9?481095.0:0.0;
}

float PrintValue(vec2 fragCoord, vec2 vPixelCoords, vec2 vFontSize, float fValue, float fMaxDigits, float fDecimalPlaces)
{
    vec2 vStringCharCoords = (fragCoord.xy - vPixelCoords) / vFontSize;
    if ((vStringCharCoords.y < 0.0) || (vStringCharCoords.y >= 1.0)) return 0.0;
    float fLog10Value = log2(abs(fValue)) / log2(10.0);
    float fBiggestIndex = max(floor(fLog10Value), 0.0);
    float fDigitIndex = fMaxDigits - floor(vStringCharCoords.x);
    float fCharBin = 0.0;
    if(fDigitIndex > (-fDecimalPlaces - 1.01)) {
        if(fDigitIndex > fBiggestIndex) {
            if((fValue < 0.0) && (fDigitIndex < (fBiggestIndex+1.5))) fCharBin = 1792.0;
        } else {        
            if(fDigitIndex == -1.0) {
                if(fDecimalPlaces > 0.0) fCharBin = 2.0;
            } else {
                if(fDigitIndex < 0.0) fDigitIndex += 1.0;
                float fDigitValue = (abs(fValue / (pow(10.0, fDigitIndex))));
                float kFix = 0.0001;
                fCharBin = DigitBin(int(floor(mod(kFix+fDigitValue, 10.0))));
            }       
        }
    }
    return floor(mod((fCharBin / pow(2.0, floor(fract(vStringCharCoords.x) * 4.0) + (floor(vStringCharCoords.y * 5.0) * 4.0))), 2.0));
}

//打印数值
vec3 debug(vec2 fragCoord,float value)
{
    vec3 vColour = vec3(0.0);

    // Multiples of 4x5 work best
    vec2 vFontSize = vec2(8.0, 15.0);

    // Print Date
    vColour = mix( vColour, vec3(1.0, 1.0, 0.0), PrintValue(fragCoord, vec2(0.0 + 72.0, 100.0), vFontSize, value, 4.0, 0.0));
    
    return vColour;
}


// vec2 shockwave()
// {
//     float currentRadius = CC_Time[1] * 10.0;
//     vec2 texCoord = v_texCoord;
    
//     float dis = distance(v_position, center);
    
//     if (dis <= (currentRadius + shockParams.z) && dis >= (currentRadius - shockParams.z))
//     {
//         float diff = (dis - currentRadius) / shockParams.z; //form -1 -> 1
        
//         float powDiff = (1.0 - pow(abs(diff), shockParams.y)) * diff;
        
//         vec2 dir = normalize(center - v_position);   // / resolution.xy;
        
//         dir = dir * powDiff;
        
//         texCoord = texCoord  +  ( dir * shockParams.x ).xy / resolution.xy; // + dir * shockParams.x 
//     }
//     return texCoord;
// }

void main()
{

    vec4 color = texture2D(CC_Texture0, v_texCoord);

    //gl_FragColor = vec4(1,1,1,1);
    
    
    if(color.a == 0.0)
    {
        gl_FragColor = color;
    }
    else
    {
        // float currentRadius = mod(CC_Time[1] * 100.0,200.0);
        vec2 texCoord = v_texCoord;
        
        float dis = distance(v_position, center);
        
        if (dis <= (currentRadius + shockParams.z) && dis >= (currentRadius - shockParams.z))
        {
            float diff = (dis - currentRadius) / shockParams.z; //form -1 -> 1
            
            float powDiff = (1.0 - pow(abs(diff), shockParams.y)) * diff;
            
            vec2 dir = normalize(center - v_position);   // / resolution.xy;
            
            dir = dir * powDiff;
            
            texCoord = texCoord + (dir * shockParams.x ).xy / resolution.xy; // + dir * shockParams.x  texCoord  + 
        }

        //vec3 debugColor = debug(vec2(resolution.x * texCoord.x,resolution.y * texCoord.y),v_position.y);

        gl_FragColor = v_fragmentColor * texture2D(CC_Texture0, texCoord);//  + vec4(debugColor,0.0); //vec4((resolution.y - v_position.y) / resolution.y);//
    }
}

