#ifdef GL_ES
precision mediump float;
#endif
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

varying vec4 v_normal1;

// 🌦️ Overlay
vec4 overlay(vec4 col)
{
    vec4 outColor = vec4(0., 0., 0., col.a);
    vec4 blend = vec4(0.6, 0.6, 0.6, 1);

    if (col.r > 0.5)
    {
        outColor.r = (1.0 - 2.0*(1.0 - col.r) * (1.0 - blend.r));
    }
    else
    {
        outColor.r = ((2.0 * col.r) * blend.r);
    }

    if (col.g > 0.5)
    {
        outColor.g = (1.0 - 2.0*(1.0 - col.g) * (1.0 - blend.g));
    }
    else
    {
        outColor.g = ((2.0 * col.g) * blend.g);
    }

    if (col.b > 0.5)
    {
        outColor.b = (1.0 - 2.0*(1.0 - col.b) * (1.0 - blend.b));
    }
    else
    {
        outColor.b = ((2.0 * col.b) * blend.b);
    }

    return outColor;
}

void main()
{
    //    Rs，Gs，Bs，As；
    //
    //    目标的RGBA：  Rd，Gd，Bd，Ad；
    //
    //    源的各个运算因子：  N_Rs，N_Gs，N_Bs，N_As；
    //
    //    目标的各个运算因子：   N_Rd，N_Gd，N_Bd，N_Ad；
    //
    //    混合后的RGBA为：(Rs*N_Rs+ Rd* N_Rd，Gs*N_Gs+ Gd* N_Gd，
    //
    //               Bs*N_Bs+ Bd* N_Bd，As*N_As+ Ad* N_Ad
    vec4 src_vec4 = texture2D(CC_Texture0, v_texCoord);
    vec4 det_vec4 = texture2D(CC_Texture0, v_normal1.xy);

    if(v_normal1.z > 1.5){//light
        src_vec4 = overlay(src_vec4);
    }else if(v_normal1.z > .5){//gray
        src_vec4.rgb = vec3(0.7126*src_vec4.r + 0.0152*src_vec4.g + 0.2722*src_vec4.b);
    }

    vec4 fanle = src_vec4 * det_vec4;
    gl_FragColor = vec4(fanle.xyz * src_vec4.a, src_vec4.a);

    //gl_FragColor = src_vec4;
}
